# FKeyCommand

将客户端按 F 键的双持切换功能改为执行命令

自从 1.9 出了双持功能以后，你就可以通过 F 键来将物品交换左右手，而对于我这种喜欢玩红石和建筑的人来说，这个功能非常鸡肋。

那么我也不能让它闲着，有什么办法可以利用起来呢？这个插件就是一个例子。

创意来自 [FCommand](http://www.mcbbs.net/thread-798562-1-2.html) 插件，但是这个插件功能太少，因此我就想着自己重写一个，于是就有了这个作品。

理论上支持 1.9+ 的所有版本，如果有不支持的版本请通过回复告诉我。

Spigot 插件帖：https://www.spigotmc.org/resources/fkeycommand.62655/

## 支持功能

1. 支持按下 F 执行指定命令
2. 支持潜行按下 F 执行指定命令
3. 支持抬头按下 F 执行指定命令（抬头角度 > 80°）
4. 支持低头按下 F 执行指定命令（低头角度 > 80°）
5. 支持 PlaceholderAPI 变量
6. 支持设置按键冷却时间
7. 可以设置特定操作不影响双持切换物品

## 如何使用

* 首先在 Release 页面下载插件
* 丢进服务端的 `plugins/` 文件夹
* 启动或重启服务器，也可以用 PlugMan / Yum 执行载入插件
* 编辑 `plugins/FKeyCommand/config.yml`，根据提示增加你的命令
* 保存，输入 `/fkey reload` 重载配置

## 权限列表

默认给下面这两个权限就行了

- `fkey.use` 给普通玩家的权限，可以使用所有功能
- `fkey.admin` 给管理员的权限，可以重载配置文件

如果你想单独设置每个功能的权限，请看下面

- `fkey.normalf` 正常按下 F
- `fkey.sneakingf` 潜行时按下 F
- `fkey.lookupf` 抬头时按下 F
- `fkey.lookdownf` 低头时按下 F

## PlaceholderAPI 变量

支持使用 PlaceholderAPI 变量，例如 `%player_name%`

如果服务器安装了 PlaceholderAPI 插件，相关功能会自动启动。

## 多条命令

支持同时执行多条命令，每条命令用英文分号 ; 隔开，如果命令内容本身带有分号，请用 %3B 替换

## 配置文件

以下是参考用的配置文件

```
# FKeyCommand by Akkariin
# 支持 PlaceholderAPI 变量，需要安装该插件才能使用
# 支持多条命令，用英文分号 ; 隔开，如果命令中含有分号，请用 %3B 代替
# 如果设置为 "" 即留空，将不会执行命令，同时也不会影响双持切换物品
# 当正常按下 F 时
NormalF: "say %player_name% 牛逼！;say 我是第二条命令"
# 当潜行按下 F 时
SneakingF: "say 潜行按下 F"
# 当抬头按下 F 时
LookUpF: "say 抬头按下 F"
# 当低头按下 F 时
LookDownF: "say 低头按下 F"
# 需要间隔多久才能按一次
Delay: 5
# 按太快的时候提示内容，也支持 PlaceholderAPI
TooFast: "&c[&6FKeyCommand&c] &e按这么快想累死我呀！"
```

## 截图

![img](https://i.natfrp.org/baf16528232718addc7cfa7fdd48956e.png)

## 协议

本项目使用 GPL v3.0 协议开放源代码

